MODULE CLIErrors;

 (*
    CLIErrors - Error reporting.       
    Copyright (C) 1996 Michael Griebling
 
    This module is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This module is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*)

IMPORT io:=Out;

TYPE
  String = ARRAY 25 OF CHAR;
  ErrorList = ARRAY 13 OF String;
  
CONST
  (* Scanner errors *) 
  IllegalExpression* = 10;
  IllegalVariable*   = 11;
  TooManyVariables*  = 12;

VAR
  ErrorS : ErrorList;

PROCEDURE DisplayString * (title, str: ARRAY OF CHAR);
BEGIN
  io.Ln; io.String("*** "); io.String(title); io.String(" : ");
  io.String(str); io.Ln
END DisplayString;

PROCEDURE DisplayError * (err, errpos: INTEGER; str: ARRAY OF CHAR);
BEGIN
  io.String(str); io.Ln;                   (* error line *)
  WHILE errpos>2 DO io.Char(" "); DEC(errpos) END;  (* space to error *)
  io.Char("^");
  DisplayString("Error", ErrorS[err])
END DisplayError;

BEGIN
  ErrorS[0] := "OKay";
  ErrorS[1] := "Arithmetic overflow";
  ErrorS[2] := "Arithmetic underflow";
  ErrorS[3] := "Division by zero";
  ErrorS[4] := "Too few digits selected";
  ErrorS[5] := "Too many digits selected";
  ErrorS[6] := "Illegal number entered";
  ErrorS[7] := "Undefined variable";
  ErrorS[8] := "Illegal operator";
  ErrorS[9] := "Mismatched braces";
  ErrorS[10]:= "Illegal expression";
  ErrorS[11]:= "Illegal variable";
  ErrorS[12]:= "Too many variables";
END CLIErrors.
