MODULE UnixCalc;

 (*
    UnixCalc - Command line interface.       
    Copyright (C) 1996 Michael Griebling
 
    This module is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This module is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*)

IMPORT eq := Equations, el := UnixExecLists, io:=Out, m := ExMathLib0, 
       In, c := ExComplexLib0, sc:=Scanner, s:=Settings;

VAR
  CommandLine: sc.String;
  res: c.ExComplexType;

BEGIN
  io.String("UnixCalc V1.3 Copyright (c) 1996, 1997 by Michael Griebling"); io.Ln; 
  io.String("UnixCalc comes with ABSOLUTELY NO WARRANTY; for details see COPYING file."); io.Ln;
  io.String("This is free software, and you are welcome to redistribute it"); io.Ln;
  io.String("under certain conditions; view COPYING file for details."); io.Ln;
  io.Ln;
  io.String("Type `help' at the prompt for a list of functions."); io.Ln;
  LOOP
    io.String("UnixCalc");
    CASE m.AngleUnit OF
      | m.Degrees  : io.Char("D")
      | m.Radians  : io.Char("R")
      | m.Gradians : io.Char("G")
    END;
    IF s.State.LocalBase # 10 THEN
      io.String("Bas");
      io.LongInt(s.State.LocalBase, 1);
    END;
    io.String("> "); io.Flush;
    In.Line(CommandLine);
    IF CommandLine[0]=0X THEN
      EXIT;
    END;

    IF eq.Evaluate(CommandLine, res) THEN c.ComplexToStr(res, CommandLine);
      io.String(CommandLine); io.Ln;
      el.Append(eq.Results, CommandLine)
    END
  END
END UnixCalc.
